# Add Redundancy to a Single Virtual Device

Add a secondary device to an active virtual device to create a redundant pair. Adding resiliency to an existing device eliminates the need to start over with two new devices.

Some attributes of the secondary device must be the same as that of the primary, including:

* The device configuration
* Licensing
* Device resources
* Software package
* License throughput

If both devices belong to the same account, the term length of the secondary must be the same as that of the primary.

You can customize the following secondary-device attributes:

* Version
* Hostname
* Notification list
* List of SSH users
* Access IP addresses
* Additional bandwidth

## Prerequisites[​](#prerequisites "Direct link to Prerequisites")

* A single, non-redundant Network Edge virtual device.
* The `Network Edge Device Manager` role.

- Portal
- API

1. Sign in to the [Equinix Customer Portal](https://portal.equinix.com/) and navigate to *Network Edge*.

2. From the *Network Edge* menu, select **Virtual Device Inventory**.

   ![](/zh-Hans/assets/images/inventory-link-80bd81084841d1d70e2f07b7b8db0286.png)

3. Click on the device you want to edit. The virtual device details will display.

1) Authenticate - Submit your user credentials, Client ID, and Client Secret for OAuth2 authentication. Refer to [API Authentication](/zh-Hans/equinix-api/api-authentication.md) for instructions on how to call the OAuth API to validate and authenticate your credentials.

2) Get the Primary Device information. Send a `GET` request to the [`/ne/v1/devices`](/zh-Hans/api-catalog/network-edgev1/#tag/Virtual-Device/operation/getVirtualDevices) endpoint to list your virtual devices. Identify which device you are adding a secondary to and send a `GET` request to get the [`/ne/v1/devices/{uuid}`](/zh-Hans/api-catalog/network-edgev1/#tag/Virtual-Device/operation/getVirtualDeviceByUuid) endpoint to get the primary device's attributes.

## Adding the Secondary Virtual Device[​](#adding-the-secondary-virtual-device "Direct link to Adding the Secondary Virtual Device")

* Portal
* API

1. From your *Virtual Device Inventory*, click the name of the virtual device to view its *Virtual Device Details*.

2. Click **Add a Secondary Device**.

   ![](/zh-Hans/assets/images/add-secondary-button-d8e35fe81a131e1e79c6a7444f8ab6de.png)

3. The vendor package is automatically set to be the same as your primary device. You don't need to select or configure the vendor package for the secondary device.

4. For *Select Deployment Type* the following options are automatically configured:

   * **Redundant Device**
   * **Add an additional, redundant device to an existing device**
   * The location and the primary virtual device

   ![](/zh-Hans/assets/images/add-secondary-deployment-type-9f7872e00e2c1791af284bd6704416f8.png)

5. Click **Begin Creating Edge Devices**.

6. Select a location for the secondary device. By default, *Select the same Metro as your primary device* is checked, and the Metro of the primary device selected.

   To select a different Metro location, uncheck *Select the same Metro as your primary device*, and select a different Metro.

7. Select a billing account from the drop-down list, or click *Select the same billing account as your existing primary device*.

   信息

   Click **View Primary Device Summary** to view account details, device details, license information, notification details, and bandwidth information for the primary device.

   ![](/zh-Hans/assets/images/add-secondary-location-12c02c00e2203a249a1380244ae5cd3b.png)

8. Click **Next: Device Details**.

9. Most of the *Device Details* must be the same as the primary device, are automatically selected, and can't be modified. But:

   * If different (newer) software versions for the secondary device are supported, having two devices in a redundant pair with different software versions might affect performance. We recommend that you update the software version for your primary device.

   * You can give your secondary device a different name.

   * If you chose a different billing account than the one used for the primary device, select a term length in the *Term Length* section.

10. Click **Next: Additional Services**.

11. Select any additional services for the secondary device. They default to the same selections as the primary device.

    * To modify *Device Access*, uncheck *Same as Primary Device* and configure the secondary device's access configuration.

    * To modify the *Access Control List Templates*, uncheck *Same as Primary Device* and select one from the drop-down list or create a new one.

    * To add additional bandwidth to the secondary device, select a bandwidth from the *Secondary Device Bandwidth* drop-down.

    ![](/zh-Hans/assets/images/add-secondary-additional-services-3f59c94db03d9879df4b7c248fb18ce8.png)

12. Click **Next: Review** and review your order. In the *Shared Support Structure* section, you must click *I have reviewed this support policy and acknowledge it.*

    ![](/zh-Hans/assets/images/add-secondary-review-e1a5be022388a8dd90bf71919705048a.png)

13. Click **Create Virtual Device**.

To create a secondary device, send a `POST` request to the [`/ne/v1/devices`](/zh-Hans/api-catalog/network-edgev1/#tag/Virtual-Device/operation/createVirtualDevice) endpoint. In the body of the request, specify:

* Your primary device's UUID to `primaryDeviceUuid`.
* The secondary device configuration in the `secondary` object. Note that if different (newer) software versions for the secondary device are supported, having two devices in a redundant pair with different software versions might affect performance. We recommend that you update the software version for your primary device.

Sample cURL Request:

```
curl -X POST "https://api.equinix.com/ne/v1/devices" \

-H "content-type: application/json" \

-H "Authorization: Bearer <token>" \

-d '{

  "primaryDeviceUuid": "device_uuid",

  "secondary": {

    "metroCode": "<metro_code>",

    "version": "<version_number>",

    "virtualDeviceName": "<secondary_device_name>",

    "hostNamePrefix": "<secondary_device_hostname_prefix>",

    "notifications": [

      "<contact_email>"

    ],

    "termLength": 1,

    "aclDetails": [

      {

        "uuid": "<acl_uuid>",

        "interfaceType": "<acl_interface_type>"

      }

    ],

    "userPublicKey": {

      "username": "<username>",

      "keyName": "<keyname>"

    },

    "licenseFileId": "<license_file_id>",

    "accountNumber": "<account_number>"

  }

}'
```

Include `licenseFileId` only if your vendor and license mode require a license file.

For a complete list of parameters and options, see the [API Reference](/zh-Hans/api-catalog/network-edgev1#operation/createVirtualDevice).

While the secondary device is being provisioned, the status of the primary device will change to `WAITING_FOR_SECONDARY`. If the secondary fails to provision, the primary will move back to the provisioned state. If the secondary provisions, then the status of both the devices will change to `PROVISIONED`.
